<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2015 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

define('_JEXEC', 1);
defined( '_JEXEC' ) or die( 'Restricted access' );
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace('/modules/mod_paymybill/return','', dirname(__FILE__));
if (file_exists($dirname . '/defines.php')) {
	include_once $dirname . '/defines.php';
}

if (!defined('_JDEFINES')) {
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.'/includes/defines.php';
}

require_once JPATH_BASE.'/includes/framework.php';

// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;

// Instantiate the application.
$app = JFactory::getApplication('site');

// Initialise the application.
$app->initialise();

$lang = JFactory::getLanguage();
$extension = 'mod_paymybill';
$language_tag = $lang->getTag();
$reload = true;
$lang->load($extension, $dirname, $language_tag, $reload);

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();

$session_id=isset($_GET['order_id'])?$_GET['order_id']:"";

if($session_id=="")
  exit;
$module_id=0;
$tarr=explode("-",$session_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  exit;

$order_paid=0;
$params=$PMBHelper->getWorkingModParams($module_id);

$x_SHA2_Hash=isset($_POST['x_SHA2_Hash'])?$_POST['x_SHA2_Hash']:"";
$x_response_code=isset($_POST['x_response_code'])?$_POST['x_response_code']:"";
$x_response_reason_text=isset($_POST['x_response_reason_text'])?$_POST['x_response_reason_text']:"";
$x_trans_id=isset($_POST['x_trans_id'])?$_POST['x_trans_id']:"";
$x_amount=isset($_POST['x_amount'])?$_POST['x_amount']:"";

function generateSH512($textToHash, $signatureKey)
{
  if($textToHash != null && $signatureKey != null)
  {
    $sig = hash_hmac('sha512', $textToHash, hex2bin($signatureKey));
    return strtoupper($sig);
  }
  else
  {
    return "Either Signature key or the text to hash is empty";
  }
}

if($x_SHA2_Hash!="")
{
  $signatureKey=$params['authorize_password2'];
  
  $fields_arr=array(
    'x_trans_id',
    'x_test_request',
    'x_response_code',
    'x_auth_code',
    'x_cvv2_resp_code',
    'x_cavv_response',
    'x_avs_code',
    'x_method',
    'x_account_number',
    'x_amount',
    'x_company',
    'x_first_name',
    'x_last_name',
    'x_address',
    'x_city',
    'x_state',
    'x_zip',
    'x_country',
    'x_phone',
    'x_fax',
    'x_email',
    'x_ship_to_company',
    'x_ship_to_first_name',
    'x_ship_to_last_name',
    'x_ship_to_address',
    'x_ship_to_city',
    'x_ship_to_state',
    'x_ship_to_zip',
    'x_ship_to_country',
    'x_invoice_num'
  );
  $textToHash="";
  $textToHash_arr=array();
  foreach($fields_arr as $fa)
  {
    if(isset($_POST[$fa]))
      $textToHash_arr[]=$_POST[$fa];
    else
      $textToHash_arr[]="";
  }
  $textToHash="^".implode("^",$textToHash_arr)."^";
  $x_SHA2_Hash_check=generateSH512($textToHash, $signatureKey);
  if($x_SHA2_Hash==$x_SHA2_Hash_check && $x_response_code=='1')
  {
    $order_paid=1;
  }
}

/* Debug
$mailer = JFactory::getMailer();
$mailer->setSender('mail@softpill.eu');
$mailer->addRecipient('mail@softpill.eu');
$mailer->setSubject("post request");
$mailer->setBody(print_r($_POST,true)." => ".$md5_check." ".$x_response_code);
$mailer->Send();
*/

$method_name='Authorize.net';

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($session_id);
if($order_paid == 1)
{
  //send mail
  if($params['mail_success']!=0)
  {
    $pmbf->sendConfirmationMail('success',$params,$details,$method_name);
  }
  $pmbf->setOrderSuccess($params,$details,$method_name);
}
else
{
  //send mail
  if($params['mail_cancelled']!=0)
  {
    $pmbf->sendConfirmationMail('cancelled',$params,$details,$method_name);
  }
  $pmbf->setOrderCancelled($params,$details,$method_name);
}

if($x_response_reason_text!="")
{
  $message='<h1><font color="green"><strong>'.$x_response_reason_text.'</strong></font></h1>';
  $message2='alert(\''.str_replace("'","\\'",$x_response_reason_text).'\');';
}
else
{
  $message='<h1><font color="green"><strong>'.JText::_( 'PMB_MODULE_ORDER_SUCCESS' ).'</strong></font></h1>';
  $message2='alert(\''.str_replace("'","\\'",JText::_( 'PMB_MODULE_ORDER_SUCCESS' )).'\');';
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=windows-1250">
  <meta name="generator" content="PSPad editor, www.pspad.com">
  <title></title>
  </head>
  <body>
    <?php echo $message;?>
    <a href="http://<?php echo $_SERVER['HTTP_HOST']?>">Click Here</a> to renturn to our website.
    <script type="text/javascript">
    <?php echo $message2;?>
    window.location='http://<?php echo $_SERVER['HTTP_HOST']?>';
    </script>
  </body>
</html>