<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2015 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require JPATH_BASE.'/modules/mod_paymybill/methods/vendor/autoload.php';
use net\authorize\api\contract\v1 as AnetAPI;
use net\authorize\api\controller as AnetController;
define("AUTHORIZENET_LOG_FILE", "phplog");

class PMBauthorize
{
  public $api_id="";
  public $api_key="";
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_AUTHORIZE_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_AUTHORIZE_MODULE_ERR_PASS' );
    $password_missing2=JText::_( 'PMB_AUTHORIZE_MODULE_ERR_PASS2' );
    $vendor_name=trim($params->get('authorize_user'));
    $vendor_password=trim($params->get('authorize_password'));
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }
    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
/*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
*/
    $module_id=0;
    $tarr=explode("-",$details['order_id']);
    if(count($tarr)==3)
      $module_id=$tarr[1];
    $vendor_name=trim($params->get('authorize_user'));
    $vendor_password=trim($params->get('authorize_password'));
    $this->api_id=$vendor_name;
    $this->api_key=$vendor_password;
    
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('authorize_trans_cost')+0;
    $percent_per_transaction=$params->get('authorize_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('authorize_user'));
    $vendor_password=trim($params->get('authorize_password'));
    $mode=$params->get('authorize_mode');
    $currency="";
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
    $pmbf=new PMBFunctions();
    if($params->get('mail_pending')!=0)
    {
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'Authorize');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'Authorize');
    
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }

    $api_login_id = $vendor_name;
    $transaction_key = $vendor_password;
    $amount = $payment;
    
    $test=0;
    if($mode=="TEST")
      $test=1;
    
    $this->getAnAcceptPaymentPage($payment,$test,$module_id,$details,$all_params);
    
    //print_r($details);
  }
  
  function getAnAcceptPaymentPage($amount=0,$test=0,$module_id=0,$details=array(),$params=array())
  {
      /* Create a merchantAuthenticationType object with authentication details
         retrieved from the constants file */
      $merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
      $merchantAuthentication->setName($this->api_id);
      $merchantAuthentication->setTransactionKey($this->api_key);
      $country_codes_arr=array('AF'=>'Afghanistan', 'AL'=>'Albania', 'DZ'=>'Algeria', 'AS'=>'American Samoa', 'AD'=>'Andorra', 'AO'=>'Angola', 'AI'=>'Anguilla', 'AQ'=>'Antarctica', 'AG'=>'Antigua and Barbuda', 'AR'=>'Argentina', 'AM'=>'Armenia', 'AW'=>'Aruba', 'AU'=>'Australia', 'AT'=>'Austria', 'AZ'=>'Azerbaijan', 'BS'=>'Bahamas', 'BH'=>'Bahrain', 'BD'=>'Bangladesh', 'BB'=>'Barbados', 'BY'=>'Belarus', 'BE'=>'Belgium', 'BZ'=>'Belize', 'BJ'=>'Benin', 'BM'=>'Bermuda', 'BT'=>'Bhutan', 'BO'=>'Bolivia', 'BA'=>'Bosnia and Herzegowina', 'BW'=>'Botswana', 'BV'=>'Bouvet Island', 'BR'=>'Brazil', 'IO'=>'British Indian Ocean Territory', 'BN'=>'Brunei Darussalam', 'BG'=>'Bulgaria', 'BF'=>'Burkina Faso', 'BI'=>'Burundi', 'KH'=>'Cambodia', 'CM'=>'Cameroon', 'CA'=>'Canada', 'XC'=>'Canary Islands', 'CV'=>'Cape Verde', 'KY'=>'Cayman Islands', 'CF'=>'Central African Republic', 'TD'=>'Chad', 'CL'=>'Chile', 'CN'=>'China', 'CX'=>'Christmas Island', 'CC'=>'Cocos (Keeling) Islands', 'CO'=>'Colombia', 'KM'=>'Comoros', 'CG'=>'Congo', 'CK'=>'Cook Islands', 'CR'=>'Costa Rica', 'CI'=>'Cote D\'Ivoire', 'HR'=>'Croatia', 'CU'=>'Cuba', 'CY'=>'Cyprus', 'CZ'=>'Czech Republic', 'DK'=>'Denmark', 'DJ'=>'Djibouti', 'DM'=>'Dominica', 'DO'=>'Dominican Republic', 'TP'=>'East Timor', 'XE'=>'East Timor', 'EC'=>'Ecuador', 'EG'=>'Egypt', 'SV'=>'El Salvador', 'GQ'=>'Equatorial Guinea', 'ER'=>'Eritrea', 'EE'=>'Estonia', 'ET'=>'Ethiopia', 'FK'=>'Falkland Islands (Malvinas)', 'FO'=>'Faroe Islands', 'FJ'=>'Fiji', 'FI'=>'Finland', 'FR'=>'France', 'FX'=>'France, Metropolitan', 'GF'=>'French Guiana', 'PF'=>'French Polynesia', 'TF'=>'French Southern Territories', 'GA'=>'Gabon', 'GM'=>'Gambia', 'GE'=>'Georgia', 'DE'=>'Germany', 'GH'=>'Ghana', 'GI'=>'Gibraltar', 'GR'=>'Greece', 'GL'=>'Greenland', 'GD'=>'Grenada', 'GP'=>'Guadeloupe', 'GU'=>'Guam', 'GT'=>'Guatemala', 'GN'=>'Guinea', 'GW'=>'Guinea-bissau', 'GY'=>'Guyana', 'HT'=>'Haiti', 'HM'=>'Heard and Mc Donald Islands', 'HN'=>'Honduras', 'HK'=>'Hong Kong', 'HU'=>'Hungary', 'IS'=>'Iceland', 'IN'=>'India', 'ID'=>'Indonesia', 'IR'=>'Iran (Islamic Republic of)', 'IQ'=>'Iraq', 'IE'=>'Ireland', 'IL'=>'Israel', 'IT'=>'Italy', 'JM'=>'Jamaica', 'JP'=>'Japan', 'XJ'=>'Jersey', 'JO'=>'Jordan', 'KZ'=>'Kazakhstan', 'KE'=>'Kenya', 'KI'=>'Kiribati', 'KP'=>'Korea, Democratic People\'s Republic of', 'KR'=>'Korea, Republic of', 'KW'=>'Kuwait', 'KG'=>'Kyrgyzstan', 'LA'=>'Lao People\'s Democratic Republic', 'LV'=>'Latvia', 'LB'=>'Lebanon', 'LS'=>'Lesotho', 'LR'=>'Liberia', 'LY'=>'Libyan Arab Jamahiriya', 'LI'=>'Liechtenstein', 'LT'=>'Lithuania', 'LU'=>'Luxembourg', 'MO'=>'Macau', 'MK'=>'Macedonia, The Former Yugoslav Republic of', 'MG'=>'Madagascar', 'MW'=>'Malawi', 'MY'=>'Malaysia', 'MV'=>'Maldives', 'ML'=>'Mali', 'MT'=>'Malta', 'MH'=>'Marshall Islands', 'MQ'=>'Martinique', 'MR'=>'Mauritania', 'MU'=>'Mauritius', 'YT'=>'Mayotte', 'MX'=>'Mexico', 'FM'=>'Micronesia, Federated States of', 'MD'=>'Moldova, Republic of', 'MC'=>'Monaco', 'MN'=>'Mongolia', 'ME'=>'Montenegro', 'MS'=>'Montserrat', 'MA'=>'Morocco', 'MZ'=>'Mozambique', 'MM'=>'Myanmar', 'NA'=>'Namibia', 'NR'=>'Nauru', 'NP'=>'Nepal', 'NL'=>'Netherlands', 'AN'=>'Netherlands Antilles', 'NC'=>'New Caledonia', 'NZ'=>'New Zealand', 'NI'=>'Nicaragua', 'NE'=>'Niger', 'NG'=>'Nigeria', 'NU'=>'Niue', 'NF'=>'Norfolk Island', 'MP'=>'Northern Mariana Islands', 'NO'=>'Norway', 'OM'=>'Oman', 'PK'=>'Pakistan', 'PW'=>'Palau', 'PA'=>'Panama', 'PG'=>'Papua New Guinea', 'PY'=>'Paraguay', 'PE'=>'Peru', 'PH'=>'Philippines', 'PN'=>'Pitcairn', 'PL'=>'Poland', 'PT'=>'Portugal', 'PR'=>'Puerto Rico', 'QA'=>'Qatar', 'RE'=>'Reunion', 'RO'=>'Romania', 'RU'=>'Russian Federation', 'RW'=>'Rwanda', 'KN'=>'Saint Kitts and Nevis', 'LC'=>'Saint Lucia', 'VC'=>'Saint Vincent and the Grenadines', 'WS'=>'Samoa', 'SM'=>'San Marino', 'ST'=>'Sao Tome and Principe', 'SA'=>'Saudi Arabia', 'SN'=>'Senegal', 'RS'=>'Serbia', 'SC'=>'Seychelles', 'SL'=>'Sierra Leone', 'SG'=>'Singapore', 'SK'=>'Slovakia (Slovak Republic)', 'SI'=>'Slovenia', 'SB'=>'Solomon Islands', 'SO'=>'Somalia', 'ZA'=>'South Africa', 'GS'=>'South Georgia and the South Sandwich Islands', 'ES'=>'Spain', 'LK'=>'Sri Lanka', 'XB'=>'St. Barthelemy', 'XU'=>'St. Eustatius', 'SH'=>'St. Helena', 'PM'=>'St. Pierre and Miquelon', 'SD'=>'Sudan', 'SR'=>'Suriname', 'SJ'=>'Svalbard and Jan Mayen Islands', 'SZ'=>'Swaziland', 'SE'=>'Sweden', 'CH'=>'Switzerland', 'SY'=>'Syrian Arab Republic', 'TW'=>'Taiwan', 'TJ'=>'Tajikistan', 'TZ'=>'Tanzania, United Republic of', 'TH'=>'Thailand', 'DC'=>'The Democratic Republic of Congo', 'TG'=>'Togo', 'TK'=>'Tokelau', 'TO'=>'Tonga', 'TT'=>'Trinidad and Tobago', 'TN'=>'Tunisia', 'TR'=>'Turkey', 'TM'=>'Turkmenistan', 'TC'=>'Turks and Caicos Islands', 'TV'=>'Tuvalu', 'UG'=>'Uganda', 'UA'=>'Ukraine', 'AE'=>'United Arab Emirates', 'GB'=>'United Kingdom', 'US'=>'United States', 'UM'=>'United States Minor Outlying Islands', 'UY'=>'Uruguay', 'UZ'=>'Uzbekistan', 'VU'=>'Vanuatu', 'VA'=>'Vatican City State (Holy See)', 'VE'=>'Venezuela', 'VN'=>'Viet Nam', 'VG'=>'Virgin Islands (British)', 'VI'=>'Virgin Islands (U.S.)', 'WF'=>'Wallis and Futuna Islands', 'EH'=>'Western Sahara', 'YE'=>'Yemen', 'ZM'=>'Zambia', 'ZW'=>'Zimbabwe');
      // Set the transaction's refId
      $refId = $details['order_id'];
      
      // Create order information
      $order = new AnetAPI\OrderType();
      $order->setInvoiceNumber($details['InvNr']);
      $order->setDescription($params['product_name']);
      
      //create a transaction
      $transactionRequestType = new AnetAPI\TransactionRequestType();
      $transactionRequestType->setTransactionType("authCaptureTransaction");
      $transactionRequestType->setAmount($amount);
      $transactionRequestType->setOrder($order);
      /*
      //print_r($details);exit;*/
      // Set the customer's Bill To address
      $customerAddress = new AnetAPI\CustomerAddressType();
      $customerAddress->setFirstName($details["BillFname"]);
      $customerAddress->setLastName($details["BillLname"]);
      $customerAddress->setCompany("");
      $customerAddress->setAddress($details["BillAddr"]);
      $customerAddress->setCity($details["BillCity"]);
      $customerAddress->setState($details["BillState"]);
      //$customerAddress->setPhoneNumber($details["BillPhone"]);
      $customerAddress->setZip($details["BillZip"]);
      $customerAddress->setCountry($country_codes_arr[$details["BillCountry"]]);
      $transactionRequestType->setBillTo($customerAddress);
      $transactionRequestType->setShipTo($customerAddress);
      
      // Set the customer's identifying information
      $customerData = new AnetAPI\CustomerDataType();
      $customerData->setType("individual");
      $customerData->setId($details["id"]);
      $customerData->setEmail($details["BillEmail"]);
      $transactionRequestType->setCustomer($customerData);
      
      // Set Hosted Form options
      $setting1 = new AnetAPI\SettingType();
      $setting1->setSettingName("hostedPaymentButtonOptions");
      $setting1->setSettingValue("{\"text\": \"Pay\"}");
      $setting2 = new AnetAPI\SettingType();
      $setting2->setSettingName("hostedPaymentOrderOptions");
      $setting2->setSettingValue("{\"show\": false}");
      $setting3 = new AnetAPI\SettingType();
      $setting3->setSettingName("hostedPaymentReturnOptions");
      $setting3->setSettingValue(
          "{\"showReceipt\": false, \"url\": \"".str_replace("&","%26",JUri::getInstance())."\", \"urlText\": \"Continue\", \"cancelUrl\": \"".str_replace("&","%26",JUri::getInstance())."\", \"cancelUrlText\": \"Cancel\"}"
      );
      $setting4 = new AnetAPI\SettingType();
      $setting4->setSettingName("hostedPaymentIFrameCommunicatorUrl");
      $setting4->setSettingValue("{\"url\": \"".juri::base()."modules/mod_paymybill/methods/vendor/ifrm.php\"}");
      
      $setting5 = new AnetAPI\SettingType();
      $setting5->setSettingName("hostedPaymentBillingAddressOptions");
      $setting5->setSettingValue("{\"show\": true, \"required\": true}");
      
      $setting6 = new AnetAPI\SettingType();
      $setting6->setSettingName("hostedPaymentCustomerOptions");
      $setting6->setSettingValue("{\"showEmail\": true, \"requiredEmail\": true, \"addPaymentProfile\": true}");
      
      $setting7 = new AnetAPI\SettingType();
      $setting7->setSettingName("hostedPaymentSecurityOptions");
      $setting7->setSettingValue("{\"captcha\": true}");
      
      // Build transaction request
      $request = new AnetAPI\GetHostedPaymentPageRequest();
      $request->setMerchantAuthentication($merchantAuthentication);
      $request->setRefId($refId);
      $request->setTransactionRequest($transactionRequestType);
      $request->addToHostedPaymentSettings($setting1);
      $request->addToHostedPaymentSettings($setting2);
      $request->addToHostedPaymentSettings($setting3);
      $request->addToHostedPaymentSettings($setting4);
      $request->addToHostedPaymentSettings($setting5);
      $request->addToHostedPaymentSettings($setting6);
      $request->addToHostedPaymentSettings($setting7);
      
      //execute request
      $controller = new AnetController\GetHostedPaymentPageController($request);
      
      if($test==1)
        $response = $controller->executeWithApiResponse(\net\authorize\api\constants\ANetEnvironment::SANDBOX);
      else
        $response = $controller->executeWithApiResponse(\net\authorize\api\constants\ANetEnvironment::PRODUCTION);
      
      $url="https://accept.authorize.net/payment/payment";
      if($test==1)
        $url="https://test.authorize.net/payment/payment";
      
      
      if (($response != null) && ($response->getMessages()->getResultCode() == "Ok")) {
      ?>
      <iframe id="load_payment<?php echo $module_id;?>" style="display:block;" id="load_payment" class="embed-responsive-item" name="load_payment" width="100%" height="1067px" frameborder="0" scrolling="no" hidden="true"></iframe>
      <form name="send_hptoken" action="<?php echo $url;?>" method="post" target="load_payment" >
				<input type="hidden" name="token" value="<?php echo $response->getToken();?>" />
			</form>
      <script type="text/javascript">
      <!--
      jQuery(document).ready(function(){
        document.send_hptoken.submit();
        doScroll('load_payment<?php echo $module_id;?>');
      });
      function doScroll(id){
      	jQuery('html,body').animate({scrollTop: (jQuery("#"+id).offset().top)},'slow');
      }
      
      window.CommunicationHandler = {};
    	function parseQueryString(str) {
    		var vars = [];
    		var arr = str.split('&');
    		var pair;
    		for (var i = 0; i < arr.length; i++) {
    			pair = arr[i].split('=');
    			vars[pair[0]] = unescape(pair[1]);
    		}
    		return vars;
    	}
    	CommunicationHandler.onReceiveCommunication = function (argument) {
    		params = parseQueryString(argument.qstr)
    		parentFrame = argument.parent.split('/')[4];
    		//console.log(params);
    		//alert(params['height']);
    		$frame = jQuery("#load_payment<?php echo $module_id;?>");
    		switch(params['action']){
    			case "resizeWindow" 	:
          //console.log(params['height']);
    										$frame.height(parseInt(params['height'])+"px");
    										break;
    			case "successfulSave" 	: 	window.location.replace('<?php echo JUri::getInstance();?>'); break;
    			case "cancel" 			:
                        jQuery.post( "<?php echo juri::base();?>/modules/mod_paymybill/methods/vendor/controller.php", 
                          { "action": "cancel_transaction", "order_id": '<?php echo $details['order_id'];?>' })
                            .done(function( data ) {
                              doScroll('load_payment<?php echo $module_id;?>');
                              jQuery('#load_payment<?php echo $module_id;?>').attr("src","<?php echo juri::base();?>/modules/mod_paymybill/return/authorize_cancel.html");
                          });
    						 				break;
    			case "transactResponse"	:
                        
    										var transResponse = JSON.parse(params['response']);
                        if(transResponse.responseCode=='1')
                        {
                          jQuery.post( "<?php echo juri::base();?>/modules/mod_paymybill/methods/vendor/controller.php", 
                          { "action": "sucessful_transaction", "transId": transResponse.transId, "order_id": '<?php echo $details['order_id'];?>' })
                            .done(function( data ) {
                              
                              if(data!="00" && data!="01" && data!="1" && data!="2" && data!="3")
                              {
                                alert(data);
                                jQuery('#load_payment<?php echo $module_id;?>').attr("src","about:blank");
                                doScroll('load_payment<?php echo $module_id;?>');
                              }
                              if(data=="1" || data=="2" || data=="3")
                              {
                                alert("An unexpected error occured ["+data+"]. Please contact the administrator");
                                jQuery('#load_payment<?php echo $module_id;?>').attr("src","about:blank");
                                doScroll('load_payment<?php echo $module_id;?>');
                              }
                              if(data=="00")//show success message
                              {
                                doScroll('load_payment<?php echo $module_id;?>');
                                jQuery('#load_payment<?php echo $module_id;?>').attr("src","<?php echo juri::base();?>/modules/mod_paymybill/return/authorize_success_non_recurring.html");
                              }
                              if(data=="01")//show success message
                              {
                                doScroll('load_payment<?php echo $module_id;?>');
                                jQuery('#load_payment<?php echo $module_id;?>').attr("src","<?php echo juri::base();?>/modules/mod_paymybill/return/authorize_success.html");
                              }
                          });
                        }
    		}
    	}
      //-->
      </script>
      <?php
      } else {
          echo "ERROR :  Failed to get hosted payment page token\n";
          $errorMessages = $response->getMessages()->getMessage();
          echo "RESPONSE : " . $errorMessages[0]->getCode() . "  " .$errorMessages[0]->getText() . "\n";
      }
      return $response;
  }
}

?>